#include <imsls.h>

int main ()
{
    int        n_subscripts= 3;
    int        n_levels[3] = {3,2,10};
    float      p_value;
    float      *test_effects, *means, *anova_table;
    float      y[60] = {
        73.0, 102.0, 118.0, 104.0, 81.0, 
        107.0, 100.0, 87.0, 117.0, 111.0, 
        90.0, 76.0, 90.0, 64.0, 86.0, 
        51.0, 72.0, 90.0, 95.0, 78.0,
        98.0, 74.0, 56.0, 111.0, 95.0, 
        88.0, 82.0, 77.0, 86.0, 92.0, 
        107.0, 95.0, 97.0, 80.0, 98.0, 
        74.0, 74.0, 67.0, 89.0, 58.0, 
        94.0, 79.0, 96.0, 98.0, 102.0, 
        102.0, 108.0, 91.0, 120.0, 105.0, 
        49.0, 82.0, 73.0, 86.0, 81.0, 
        97.0, 106.0, 70.0, 61.0, 82.0};
    char      *labels[] = {
        "degrees of freedom for the model",
        "degrees of freedom for error",
        "total (corrected) degrees of freedom",
        "sum of squares for the model",
        "sum of squares for error",
        "total (corrected) sum of squares",
        "model mean square", "error mean square",
        "F-statistic", "p-value",
        "R-squared (in percent)","Adjusted R-squared (in percent)",
        "est. standard deviation of the model error",
        "overall mean of y",
        "coefficient of variation (in percent)"};

    char      *test_row_labels[] = {"A", "B", "A*B"};
    char      *test_col_labels[] = {
        "Source", "DF", "Sum of\nSquares", 
        "Mean\nSquare", "Prob. of\nLarger F"};

    char      *mean_row_labels[] = {
        "grand mean",
        "A1", "A2", "A3",
        "B1", "B2", 
        "A1*B1", "A1*B2", "A2*B1", "A2*B2", "A3*B1", "A3*B2"};
                           /* Perform analysis */
    p_value = imsls_f_anova_factorial(n_subscripts, n_levels, y, 
        IMSLS_ANOVA_TABLE,   &anova_table,
        IMSLS_TEST_EFFECTS,  &test_effects, 
        IMSLS_MEANS,         &means,
        0);
 
    printf("P-value = %10.6f",p_value);
                           /* Print results */
    imsls_f_write_matrix("* * * Analysis of Variance * * *\n", 15, 1,
        anova_table, 
        IMSLS_ROW_LABELS,   labels,
        IMSLS_WRITE_FORMAT, "%11.4f", 
        0);

    imsls_f_write_matrix("* * * Variation Due to the Model * * *", 3, 4,
        test_effects,
        IMSLS_ROW_LABELS,   test_row_labels,
        IMSLS_COL_LABELS,   test_col_labels,
        IMSLS_WRITE_FORMAT, "%11.4f", 
        0);

    imsls_f_write_matrix("* * * Subgroup Means * * *", 12, 1,
        means,
        IMSLS_ROW_LABELS,   mean_row_labels,
        IMSLS_WRITE_FORMAT, "%11.4f", 
        0);
